

 export function chatsReducer (state={}, {type, payload}) {
   if (!state) {
       return {}
   }

   const types = {
      CHATS_LIST() {
          let newPayload = {} 
          for (const obj of payload) {
            newPayload[obj._id] = obj
          }
        return {
            ...state,
            ...newPayload
        }
      },
      CHAT_ADD() {
        return {
            ...state,
            [payload._id]: payload
        }
      },
      CHAT_CHANGE() {
        return {
            ...state,
            [payload._id]: payload
        }
      },
//       CHAT_REMOVE() {   
//         let { [payload._id]: removed, ...newState }  = state        
//         return newState
//       },

      MSG_LIST() {

      },
      MSG_ADD() {

      },
      MSG_CHANGE() {

      },


      SOCKET_CHAT_ADD() {

      },
      SOCKET_CHAT_CHANGE() {

      },
      SOCKET_CHAT_REMOVE() {

      },

      SOCKET_MSG_ADD() {

      },
      SOCKET_MSG_CHANGE() {

      },
   }
   if (type in types) {        
      return types[type]()
   }
   return state
 }

 export const actionAddListInChats = (payload) => 
         ({type: 'CHATS_LIST', payload})

 export const actionAddChatInChats = (payload) => 
         ({type: 'CHAT_ADD', payload})

 export const actionUpdateChatInChats = (payload) => 
         ({type: 'CHAT_CHANGE', payload})

//  export const actionRemoveChatInChats = (_id) => 
//          ({type: 'CHAT_REMOVE', payload: {_id}})




 export const actionMsgListInChat = (payload) => 
         ({type: 'MSG_LIST', payload})

 export const actionAddMsgInChat = (payload) => 
         ({type: 'MSG_ADD', payload})

 export const actionUpdateMsgInChat = (payload) => 
         ({type: 'MSG_CHANGE', payload})









