import React from 'react';
import Box from '@mui/material/Box';
import AppBar from '@mui/material/AppBar';
import Toolbar from '@mui/material/Toolbar';

export const Header = ({children}) => (
   <Box sx={{ flexGrow: 1 }} >
      <AppBar position="static" >
         <Toolbar variant="dense" sx={{ minHeight:"60px" }}>
            {children}
         </Toolbar>
      </AppBar>
   </Box>
)
